#include "arrays.h"
#include "includes.h"
#include "funcs.h"
#include "defines.h"

int mp3hed(char *dir, char *argy)
{

	int framesize;
	int framesizewithhdr;
	float constantthing;
	int guess;
	long filesize;
	long filesizenotag;
	int realbitrate;
	int samplerate;
	int version;
	int layer;
	int protection;
	int bitrate;
	int sampling;
	int private;
	int padding;
	int channelmode;
	int modext;
	int copyright;
	int original;
	int emphasis;

	char a,b,c,d;

	char *filename;

	FILE * mp3file;

	constantthing=38.36;  /* was 38.28 */ /* 38.40 was more accurate */

	filename=calloc(1,255);

/*		filename=(char *)argy; */

		strcat(filename,dir);
		strcat(filename,"/");
		strcat(filename,argy);
	
		mp3file=fopen(filename,"r");
	
		if (mp3file==NULL)
		{
			mvaddstr(STATUSLINE,0,"Can't open the damn file.");
			clrtoeol();
			refresh();
			exit (1);
		}

		if (findhedder(mp3file)==EOF)
		{
			mvaddstr (STATUSLINE,0,"No header found!!!!");
			clrtoeol();
			refresh();
			return -1;
		}

	
		a=fgetc(mp3file);
		b=fgetc(mp3file);
		c=fgetc(mp3file);
		d=fgetc(mp3file);
	
		fseek(mp3file,0,SEEK_END);
		filesize=ftell(mp3file);
		filesizenotag=filesize-128;
/*		printf ("file appears to be %d bytes long.\n",filesize);  */
	
		if ((
			set(a&128) &
			set(a&64) &
			set(a&32) &
			set(a&16) &
			set(a&8) &
			set(a&4) &
			set(a&2) &
			set(a&1) &
			set(b&128) &
			set(b&64) &
			set(b&32)) != 1)
		{
			printf ("Can't find sync!\n"); 
			return -1; 
		}
	
		version=mpegver(bitint(0,0,0,0,0,0,set(b&16),set(b&8)));
		layer=layerver(bitint(0,0,0,0,0,0,set(b&4),set(b&2)));
		protection=bitint(0,0,0,0,0,0,0,set(b&1));
		bitrate=bitint(0,0,0,0,set(c&128),set(c&64),set(c&32),set(c&16));
		sampling=bitint(0,0,0,0,0,0,set(c&8),set(c&4));
		padding=bitint(0,0,0,0,0,0,0,set(c&2));
		private=bitint(0,0,0,0,0,0,0,set(c&1));
		channelmode=bitint(0,0,0,0,0,0,set(d&128),set(d&64));
		modext=bitint(0,0,0,0,0,0,set(d&32),set(d&16)); 
		copyright=bitint(0,0,0,0,0,0,0,set(d&8));
		original=bitint(0,0,0,0,0,0,0,set(d&4));
		emphasis=bitint(0,0,0,0,0,0,set(d&2),set(d&1));
	
/*		printf ("version int is %d\n",version);
		printf ("layer int is %d\n",layer);
		printf ("protection int is %d\n",protection);
		printf ("bitrate int is %d\n",bitrate);
		printf ("sampling int is %d\n",sampling);
		printf ("padding int is %d\n",padding);
		printf ("private int is %d\n",private);
		printf ("channel mode int is %d\n",channelmode);
		printf ("mode extension if joint stereo int is %d\n",modext); 
*/

	
		realbitrate =  bitrateindex[bitrate][bitrateindexx(version,layer)];
	
/*		printf ("(%d)(%d) real bit rate is %d\n",bitrate,bitrateindexx(version,layer),realbitrate); 
*/

	
		samplerate =  samplingrate[sampling][version] ;
	
/*		printf ("real sample rate is %d\n",samplerate); 
*/

	
		framesize=framesizer(layer,realbitrate,samplerate,padding);
		framesizewithhdr=framesize+4;
	
/*		printf ("frame size is %d\n",framesize); 
*/

	
		guess=(int)(1.0*filesizenotag/framesize/constantthing);
/*		printf ("I guess this file has %d frames.\n",filesize/framesize);
		printf ("I guess this file is %d seconds long.\n",guess);
*/
/*		printf ("%s %s\n",clockywock(guess),filename); */

/*		printf ("%s\n",clockywock(guess));
*/

/*		printf ("%d\n",guess);
*/
		return (int)guess;
}
